;   SetSort.sc	; 3/8/92
;	COPYRIGHT 1992 ROBIN S. ROWE
;	1313 N. Ritchie Ct., #1313
;	Chicago, IL  60610-2159	312-280-7693	

;------------------------------  SetSort.sc  ----------------  3/8/92

PROC SetSort()
PRIVATE db, nkeys, i
CANVAS ON
SWITCH
CASE NOT ISFILE("Delpx.bat"):
	QUIT "Can't delete indices without DelPx.bat"
CASE NOT ISTABLE("Dba"):
	QUIT "Can't regenerate indices without Dba table"
ENDSWITCH
SHOWMENU
	"Set" : "Set sort order of table indices to "+UPPER(SORTORDER()),
	"Quit": "Leave table indices as they are"
	TO i
IF NOT retval OR i="Quit"
THEN
	QUIT "Program terminated by user"
ENDIF
CLEAR
RESET
RUN "Delpx.bat"
@ 0,0
?? "  Copyright 1992 Rowe Software Paradox table set sort program."
VIEW "Dba"
HOME SCAN
	IF [Key Fields]>0 AND TABLERIGHTS([Table Name],"All")
	THEN
		db=[Table Name]
		nkeys=[Key Fields]
		? "Rekeying "+db+" with "+STRVAL(nkeys)+" key field"
		IF nkeys=1
		THEN
			?? "..."
		ELSE
			?? "s..."
		ENDIF
		MESSAGE "Backing up data"
		CANVAS OFF
		MENU "a"
		SELECT db
		CHECKPLUS
		DO_IT!
		IF TABLE()<>"Answer"
		THEN
			QUIT "Unable to restore table"
		ENDIF
		IF VERSION()>=3.5
		THEN
			EXECUTE "SAVETABLES"
		ENDIF
		CLEARIMAGE
		MOVETO 1
		CLEARIMAGE
		RENAME "Answer" "Xxrekeyx"
		IF VERSION()>=3.5
		THEN	
			EXECUTE "SAVETABLES"
		ENDIF
		CANVAS ON
		MESSAGE "Emptying for restructure"
		CANVAS OFF
		EMPTY db
		IF VERSION()>=3.5
		THEN
			EXECUTE "SAVETABLES"
		ENDIF
		CANVAS ON
		MESSAGE "Creating new "+db
		CANVAS OFF
		CREATE "Zzrekeyz" LIKE db
		IF VERSION()>=3.5
		THEN
			EXECUTE "SAVETABLES"
		ENDIF
		MENU "mr"
		SELECT "Zzrekeyz"
		ENTER ENTER
		FOR i FROM 1 TO nkeys
			"*" DOWN
		ENDFOR
		DO_IT!
		IF VERSION()>=3.5
		THEN
			EXECUTE "SAVETABLES"
		ENDIF
		CANVAS ON
		MESSAGE "Retrieving forms and reports"
		CANVAS OFF
		MENU "tcj"
		SELECT db
		SELECT "Zzrekeyz"
		"r"
		IF VERSION()>3.5
		THEN
			EXECUTE "SAVETABLES"
		ENDIF
		CANVAS ON
		MESSAGE "Restoring table data"
		CANVAS OFF
		RENAME "Zzrekeyz" db
		IF VERSION()>3.5
		THEN
			EXECUTE "SAVETABLES"
		ENDIF
		ADD "Xxrekeyx" db
		IF VERSION()>3.5
		THEN
			EXECUTE "SAVETABLES"
		ENDIF
		DELETE "Xxrekeyx"
		WHILE TABLE()<>"Dba"
			CLEARIMAGE
		ENDWHILE
		MOVETO "Dba"
		MOVETO FIELD "Table Name"
		LOCATE db
	ENDIF
ENDSCAN	
RESET
QUIT "Indices have been restored. Try program again."
ENDPROC

SetSort()
